=== abseil_cpp/CMake/install_test_project/CMakeLists.txt ===
#
# Copyright 2019 The Abseil Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# A simple CMakeLists.txt for testing cmake installation

cmake_minimum_required(VERSION 3.5)
project(absl_cmake_testing)

set(CMAKE_CXX_STANDARD 11)

add_executable(simple simple.cc)

find_package(absl REQUIRED)

target_link_libraries(simple absl::strings)
