=== debian/changelog ===
ros-kinetic-abseil-cpp (0.4.2-3xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- dfaconti <davide.faconti@gmail.com>  Sat, 15 Jun 2019 15:08:10 -0000

ros-kinetic-abseil-cpp (0.4.1-3xenial) xenial; urgency=high

  * should fix installation error
  * Contributors: Davide Faconti

 -- dfaconti <davide.faconti@gmail.com>  Tue, 11 Jun 2019 22:00:00 -0000

ros-kinetic-abseil-cpp (0.4.0-3xenial) xenial; urgency=high

  * updated to version 2019-05-28
  * ensure that -fPIC is set
  * fixes
  * Contributors: Alexander Rössler, Davide Faconti

 -- dfaconti <davide.faconti@gmail.com>  Mon, 27 May 2019 22:00:00 -0000

ros-kinetic-abseil-cpp (0.3.0-3xenial) xenial; urgency=high

  * typo fixed
  * updated to 2018_10_30
  * Contributors: Davide Faconti

 -- dfaconti <davide.faconti@gmail.com>  Mon, 29 Oct 2018 23:00:00 -0000

ros-kinetic-abseil-cpp (0.2.3-3xenial) xenial; urgency=high

  * Fix issue #1 <https://github.com/Eurecat/abseil-cpp/issues/1>
  * Contributors: Davide Faconti

 -- dfaconti <davide.faconti@gmail.com>  Tue, 14 Nov 2017 23:00:00 -0000

ros-kinetic-abseil-cpp (0.2.2-3xenial) xenial; urgency=high

  * removing rsync
  * Contributors: Davide Faconti

 -- dfaconti <davide.faconti@gmail.com>  Tue, 14 Nov 2017 23:00:00 -0000

ros-kinetic-abseil-cpp (0.2.0-3xenial) xenial; urgency=high

  * reorganized the files
  * Contributors: Davide Faconti

 -- dfaconti <davide.faconti@gmail.com>  Fri, 13 Oct 2017 22:00:00 -0000

ros-kinetic-abseil-cpp (0.1.3-3xenial) xenial; urgency=high

  * rebase
  * Update CMakeLists.txt
  * Contributors: Abseil Team, Bronek Kozicki, Davide Faconti, Gennadiy Civil, Gennadiy Rozental, Matt Calabrese, misterg, vslashg

 -- dfaconti <davide.faconti@gmail.com>  Thu, 12 Oct 2017 22:00:00 -0000

ros-kinetic-abseil-cpp (0.1.2-3xenial) xenial; urgency=high

  * Update CMakeLists.txt
  * Contributors: Davide Faconti

 -- dfaconti <davide.faconti@gmail.com>  Tue, 03 Oct 2017 22:00:00 -0000

ros-kinetic-abseil-cpp (0.1.1-3xenial) xenial; urgency=high

  * Merge branch 'master' of https://github.com/Eurecat/abseil-cpp
  * test removed
  * Update README.md
  * Initial Commit
  * Contributors: Abseil Team, Ben Cox, Davide Faconti, Derek Mauro, misterg

 -- dfaconti <davide.faconti@gmail.com>  Sat, 30 Sep 2017 22:00:00 -0000
