=== debian/control ===
Source: ros-kinetic-abseil-cpp
Section: misc
Priority: extra
Maintainer: dfaconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-catkin, rsync
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-abseil-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
Description: The abseil_cpp package
